=== debian/changelog ===
pd-vstplugin (0.6.1-1~exp1) experimental; urgency=medium

  * Initial release (Closes: #1117666)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 11 Oct 2025 18:19:10 +0200
