=== debian/control ===
Source: pd-vstplugin
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-puredata,
 cmake,
 fst-dev,
 libvst3sdk-dev,
 libx11-dev,
 supercollider-dev,
Standards-Version: 4.7.2
Homepage: https://git.iem.at/pd/vstplugin
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin

Package: pd-vstplugin
Architecture: any
Depends:
 ${misc:Depends},
 ${puredata:Depends},
 ${shlibs:Depends},
Recommends:
 ${puredata:Recommends},
Suggests:
 ${puredata:Suggests},
Provides:
 ${puredata:Provides},
Description: use VST plugins within Pure Data (Pd)
 the Pd object [vstplugin~] allows you to use VST (2 and 3) audio plugins
 within the Pure Data realtime computermusic environment.
 .
 Features:
  - supports all VST2 and VST3 plugins (audio effect, MIDI effect,
    instruments, etc.)
  - automate plugin parameters (sample accurate for VST3 plugins)
  - arbitrary number of inputs/outputs + VST3 multi-bus support
  - use either the native VST GUI or a generic editor
  - preset management: read/write standard VST preset files or set/get the
    plugin state as raw data to build your own preset management
  - MIDI input/output
  - transport and tempo support (for arpeggiators, sequencers, parameters
    with musical time units, etc.)
  - offline rendering
  - search for plugins in the standard VST directories or in user defined
    paths
  - bit-bridging and sandboxing
  - (optional) multithreaded plugin processing

Package: sc3-vstplugin
Architecture: any
Depends:
 supercollider-language,
 supercollider-server,
 ${misc:Depends},
 ${shlibs:Depends},
Description: use VST plugins within SuperCollider (SC3)
 the 'VSTPlugin' UGen allows you to use VST (2 and 3) audio plugins
 within the SuperCollider computermusic environment.
 .
 Features:
  - supports all VST2 and VST3 plugins (audio effect, MIDI effect,
    instruments, etc.)
  - automate plugin parameters (sample accurate for VST3 plugins)
  - arbitrary number of inputs/outputs + VST3 multi-bus support
  - use either the native VST GUI or a generic editor
  - preset management: read/write standard VST preset files or set/get the
    plugin state as raw data to build your own preset management
  - MIDI input/output
  - transport and tempo support (for arpeggiators, sequencers, parameters
    with musical time units, etc.)
  - offline rendering
  - search for plugins in the standard VST directories or in user defined
    paths
  - bit-bridging and sandboxing
  - (optional) multithreaded plugin processing
