=== vst/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,21 @@
 set_property(CACHE LOG_LEVEL PROPERTY STRINGS "SILENT;ERROR;WARNING;INFO;DEBUG;VERBOSE")
 message(STATUS "Log level: ${LOG_LEVEL}")
 target_compile_definitions(vst_public INTERFACE LOG_LEVEL=LOG_LEVEL_${LOG_LEVEL})
+# warn about old LOGLEVEL variable and remove it from the cache
+if (DEFINED LOGLEVEL)
+    message(WARNING "The LOGLEVEL option has been removed, please use LOG_LEVEL instead. "
+            "Note that the log level is now provided as a string, e.g. 'INFO'")
+    unset(LOGLEVEL CACHE)
+endif()
+
+# settings
+if (LINUX)
+    option(USE_RTLD_DEEPBIND "Load plugin modules with RTLD_DEEPBIND flag" OFF)
+    if (USE_RTLD_DEEPBIND)
+        message(STATUS "Load plugin modules with RTLD_DEEPBIND flag.")
+    endif()
+    target_compile_definitions(vst_common INTERFACE USE_RTLD_DEEPBIND=$<BOOL:${USE_RTLD_DEEPBIND}>)
+endif()
 
 # Windows version
 if (WIN32)
