=== debian/changelog ===
pd-vstplugin (0.6.2-1) unstable; urgency=medium

  * New upstream version 0.6.2
  * Drop obsolete 'Priority: optional' stanza.
  * Bump standards version to 4.7.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 01 Feb 2026 23:42:20 +0100
