=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: pd-vstplugin
 Section: sound
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
@@ -12,7 +11,7 @@
  libvst3sdk-dev,
  libx11-dev,
  supercollider-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://git.iem.at/pd/vstplugin
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-vstplugin
