=== debian/tests/control ===
Test-Command: pd -batch debian/tests/searchplugins.pd
Features:
 test-name=pd32-search-vst2,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst,
 pd-vstplugin,
 puredata-core,

Test-Command: pd -batch debian/tests/searchplugins.pd
Features:
 test-name=pd32-search-vst3,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst3,
 pd-vstplugin,
 puredata-core,

Test-Command: pd64 -batch debian/tests/searchplugins.pd
Features:
 test-name=pd64-search-vst2,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst,
 pd-vstplugin,
 puredata64-core,

Test-Command: pd64 -batch debian/tests/searchplugins.pd
Features:
 test-name=pd64-search-vst3,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 lsp-plugins-vst3,
 pd-vstplugin,
 puredata64-core,

Test-Command: debian/tests/scwrapper debian/tests/searchplugins.sc
Features:
 test-name=sc3-search-vst,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 jackd2,
 lsp-plugins-vst,
 procps,
 sc3-vstplugin,

Test-Command: debian/tests/scwrapper debian/tests/searchplugins.sc
Features:
 test-name=sc3-search-vst3,
Restrictions:
 allow-stderr,
 skip-not-installable,
Depends:
 jackd2,
 lsp-plugins-vst3,
 procps,
 sc3-vstplugin,
