=== debian/watch ===
Version: 5

Template: Gitlab
Dist: https://git.iem.at/pd/vstplugin
Uversion-Mangle: s/v//g
